<template>
    <div>
 <section class="todoapp">
     <header class="head">
         <h1>Todos</h1>
         <input type="text" class="new-todo" v-model="newTodo" @keyup.enter="addTodo"  placeholder="Ajouter une tâche">
         <button class="destroy"></button>
     </header>
     <div class="main">
         <input type="checkbox" class="toggle-all" v-model="allDone">
         <ul class="todo-list">
             <li class="todo" v-for="todo in filtered"  v-bind:key="todo" :class="{completed: todo.completed, editing : todo === editing}">
                 <div class="view">
                     <input type="checkbox" v-model="todo.completed" class="toggle">
                     <label @dblclick="editTodo(todo)"> {{ todo.name}}</label>
                     <button class="destroy" @click.prevent="deleteTodo(todo)"></button>

                 </div>
                 <input type="text" @keyup.enter="doneTodo" @keyup.esc="cancelTodo" @blur="doneTodo" class="edit" v-model="todo.name" v-focus="todo === editing">

             </li>
         </ul>
     </div>
 </section>
<footer class="footer" v-show="todos.length >0">
    <span class="todo-count"> <strong> {{ remaining }} </strong> Tâches à faire </span>
    <ul class="filters">
        <li> <a href="#" :class="{selected: filter === 'all'}" @click.prevent="filter = 'all'"> Toutes </a> </li>
        <li> <a href="#" :class="{selected: filter === 'todo'}" @click.prevent="filter = 'todo'"> A faire </a> </li>
        <li> <a href="#" :class="{selected: filter === 'done'}" @click.prevent="filter = 'done'"> Faites </a> </li>
    </ul>
    <button class="clear-completed" v-show="completed >0" @click.prevent="deleteTodoCompleted">supprimer les tâches finies</button>
</footer>
    </div>
</template>

<script>
    import Vue from 'vue'
    export default {
        name: 'Todos',
        props: { value : { type: Array , default (){ return []}} },
        data() {
            return {
                todos:this.value,
                newTodo: '',
                filter : 'all',
                editing: null,
                oldTodo: ''
            }
        },
        watch:{
            value(value) {
                    this.todos=value
            }
        },
        methods: {
            addTodo() {
                this.todos.push({name: this.newTodo, completed:false})
                this.newTodo=''
            },
            deleteTodo(todo){
               this.todos= this.todos.filter(t => t !== todo)
                this.$emit('input',this.todos)
            },
            editTodo(todo){
                this.editing= todo
                this.oldTodo = todo.name
                this.$emit('input',this.todos)
            },doneTodo(){
                this.editing= null
            },cancelTodo(){
                this.editing.name = this.oldTodo
                this.doneTodo()
            },
            deleteTodoCompleted(){
                this.todos = this.todos.filter(t => !t.completed)
                this.$emit('input',this.todos)
            }

        }, computed:{

            allDone:{
                get(){
                    return this.remaining == 0 ;
                },
                set (value){
                    this.todos.forEach( todo => todo.completed = value)
                }
            },
            completed (){
                return this.todos.filter(todo => todo.completed).length
            },
            remaining (){
               return this.todos.filter(todo => !todo.completed).length
            }, filtered(){
                console.log(this.filter)
                if (this.filter === 'todo'){
                    return this.todos.filter(todo => !todo.completed)
                }else if (this.filter === 'done') {
                    return this.todos.filter(todo => todo.completed)
                }
                return this.todos
            }
        },
        directives :{
            focus(el , value){
                if (value){
                    // eslint-disable-next-line no-unused-vars
                    Vue.nextTick( _ => { el.focus()}

                    )
                }
            }
        }
    }
</script>

<style src="./todos.css">

</style>
